﻿using HarmonyLib;
using Steamworks;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.AzureSky;
using System.Threading.Tasks;

namespace SolarPanelV2 {
    public class SolarPanelV2 : Mod {
        public static AssetBundle assetbundle;
        
        IEnumerator Start() {
            HNotification notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Loading SolarPanelMod...");

            // dev switch, if you read this and you're confused. Just ignore it.
            if (true) {
                var bundleLoadRequest = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("solarpanel.assets"));
                yield return bundleLoadRequest;

                assetbundle = bundleLoadRequest.assetBundle;

                List<Item_Base> list = Traverse.Create(typeof(ItemManager)).Field("allAvailableItems").GetValue<List<Item_Base>>();

                Item_Base placeable_solarpanel = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_solarpanel");
                placeable_solarpanel.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<SolarPanelObject>();
                SolarPanelObject obj = placeable_solarpanel.settings_buildable.GetBlockPrefab(0).gameObject.AddComponent<SolarPanelObject>();
                obj.gameObject.transform.Find("WaterTank").gameObject.AddComponent<Tank>();
                obj.GetComponent<Sprinkler>().waterTank = obj.GetComponentInChildren<Tank>();
                Traverse.Create(placeable_solarpanel.settings_buildable.GetBlockPrefab(0).GetComponentInChildren<Battery>()).Field("networkBehaviourID").SetValue(obj);
                placeable_solarpanel.settings_buildable.GetBlockPrefab(0).GetComponent<Block>().networkedIDBehaviour = obj;

                placeable_solarpanel.settings_buildable.GetBlockPrefab(0).GetComponentInChildren<Battery>().itemEnabler = ItemManager.GetItemByName("Placeable_Sprinkler").settings_buildable.GetBlockPrefab(0).GetComponentInChildren<Battery>().GetComponent<ItemObjectEnabler>();
                
                placeable_solarpanel.Initialize(999, "placeable_solarpanel", 1);

                list.Add(placeable_solarpanel);

                Traverse.Create(typeof(ItemManager)).Field("allAvailableItems").SetValue(list);

                RAPI.AddItemToBlockQuadType(placeable_solarpanel, RBlockQuadType.quad_floor);
                RAPI.AddItemToBlockQuadType(placeable_solarpanel, RBlockQuadType.quad_foundation);
                RAPI.AddItemToBlockQuadType(placeable_solarpanel, RBlockQuadType.quad_table);
            }
            
            notification.Close();
            yield return null;
        }

        public void OnModUnload() {
            Debug.Log("Mod SolarPanelV2 has been unloaded!");
        }
    }
}